//
//  TreeFliteViewController.swift
//  IFS
//
//  Created by Tiank on 2018/7/26.
//  Copyright © 2018年 上海勾芒信息科技有限公司. All rights reserved.
//

import UIKit

class TreeFliteViewController: BaseViewController {
    var dataModels:[TreeLocationModel] = [TreeLocationModel]()
    var lastSelectItem : TreeLocationModel?
    var completeBlock:(TreeLocationModel)->() = {_ in}
    let treeView = RATreeView()
    override func viewDidLoad() {
        super.viewDidLoad()
        buildBaseUI()
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        
    }
    func buildBaseUI(){
        self.navigationItem.title = "筛选楼层"
        let rightBarbutton = UIBarButtonItem(title: "确定", style: UIBarButtonItemStyle.plain, target: self, action: #selector(sureAction(item:)))
        self.navigationItem.rightBarButtonItem = rightBarbutton
        
        view.addSubview(treeView)
        treeView.frame = CGRect(x: 0, y: 0, width: kWidth, height: kHeight - WjySize.navHeitht - WjySize.extraBottom)
        treeView.dataSource = self
        treeView.delegate = self
        treeView.register(UINib(nibName: String(describing: TreeFliteLocationCell.self), bundle: nil), forCellReuseIdentifier: String(describing: TreeFliteLocationCell.self))
    }
    @objc func sureAction(item:UIBarButtonItem){
        guard lastSelectItem != nil else {
            ShowMessage("请选择选项")
            return
        }
        var tempItem = lastSelectItem!
        var path = tempItem.name ?? ""
        while (treeView.parent(forItem: tempItem) != nil) {
            if let parentItem = treeView.parent(forItem: tempItem) as? TreeLocationModel{
                path = (parentItem.name ?? "") + "/" + path
                tempItem = parentItem
            }
        }
        lastSelectItem!.name = path
        completeBlock(lastSelectItem!)
        self.navigationController?.popViewController(animated: true)
    }
}
extension TreeFliteViewController:RATreeViewDataSource,RATreeViewDelegate{
    func treeView(_ treeView: RATreeView, numberOfChildrenOfItem item: Any?) -> Int {
        if let item = item as? TreeLocationModel {
            return item.children?.count ?? 0
        }else{
            return dataModels.count
        }
    }
    
    func treeView(_ treeView: RATreeView, cellForItem item: Any?) -> UITableViewCell {
        guard let cell = treeView.dequeueReusableCell(withIdentifier: String(describing: TreeFliteLocationCell.self)) as? TreeFliteLocationCell,
            let item = item as? TreeLocationModel else {
                fatalError()
        }
        let level = treeView.levelForCell(forItem: item)
        cell.updateUI(model: item, level: level)
        return cell
    }
    
    func treeView(_ treeView: RATreeView, child index: Int, ofItem item: Any?) -> Any {
        if item == nil {
            return dataModels[index]
        }else if let item = item as? TreeLocationModel {
            return item.children?[index] ?? TreeLocationModel()
        }else{
            fatalError()
        }
    }
    func treeView(_ treeView: RATreeView, didSelectRowForItem item: Any) {
        if let item = item as? TreeLocationModel {
            lastSelectItem?.isSelect = false
            let tempItem = lastSelectItem
            item.isSelect = true
            item.isOpen = !item.isOpen
            lastSelectItem = item
            treeView.reloadRows(forItems: [tempItem ?? TreeLocationModel(),item], with: RATreeViewRowAnimationAutomatic)
        }
    }
}


























